// ------------------------------------------------------------------------------
// BallCollision - http://www.arkitus.com
// Copyright (C) 2005  Ali Eslami
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// ------------------------------------------------------------------------------
// BalCollision.java
// Procedures related to starting up the program and adjusting the settings
// are in this file.
// ------------------------------------------------------------------------------

int t = -1;
int num = 15;
Ball[] balls = new Ball[num];

float g = 0.20;                            // Gravity
float b = 0.95;                            // Bounciness
float f = 0.50;                            // Friction

void setup()
{
  size(800,420);
  framerate(30);
  smooth();
  
  stroke(0);
  strokeWeight(2);
  
  reset();
}

void draw()
{
  background(255,255,255);
  
  if ( mousePressed == true )
  {
    drag();
  }
  
  if ( keyPressed )
  {
    if ( key == '=' || key == '-' || key == '+' )
    {
      float k = 1;
    
      if ( key == '=' || key == '+' )
      {  
        k = 1.01;
      }
      else
      {
        k = 0.99;
      }
    
      for ( int i=0; i<num; i++ )
      {
        balls[i].r *= k;
      }
    }
    if ( key == ' ' )
    {
      shake();
    }
  }

  for ( int i=0; i<num; i++ )
  {
    balls[i].fall();
    balls[i].bounce();
    balls[i].collide();
    balls[i].move();
    balls[i].display();
  }
}

void mousePressed()
{
  for ( int i=0; i<num; i++ )
  {
    if ( abs(mouseX-balls[i].x) < balls[i].r && abs(mouseY-balls[i].y) < balls[i].r )
    {
      t = i;
    }
  }
}

void drag()
{
  if ( t >= 0 )
  {
    balls[t].x = mouseX;
    balls[t].y = mouseY;
  
    balls[t].vy = 0;
    balls[t].vx = 0;
  }
}

void reset()
{ 
  for ( int i=0; i<num; i++ )
  {
    balls[i] = new Ball();
  }
}

void shake()
{
  for ( int i=0; i<num; i++ )
  {
    balls[i].vx += random(-5,5);
    balls[i].vy += random(-5,5);
  }
}
